%ͻҹ+CIAԼ
%by chenxin 
%2020-11-30

var Y A K N G w Rk C lambda mu epsilonN epsilonm0 R pi I l tao dlnm m0 m;  %һ20

varexo eN em0 em ea eg; %

parameters alpha beta sigma theta eta chi delta rhoN rhom rhog rhom0 rhoA sigmaN sigmam sigmam0 sigmaa sigmag gama sb s; %13ṹԲ

parameters Ys  Ks Ns Gs ws Rks Cs lambdas mus Rs pistar Is ls taos ms m0s K_N epsilonm0s;

alpha=0.6;
beta=.99;
sigma=2;
eta=1.5;
delta=.025;
rhoN=0.6061;
rhom=0.9027;
rhom0=0.6696;
rhoA=0.9987;
rhog=0.5716;
chi=0.1;
sigmaN=.4875;
sigmam=.0329;
sigmam0=.1097;
sigmaa=.0521;
sigmag=.0406;
gama=.96;
pistar=1.02;
sb=2;
s=0.1;
epsilonm0s=6.15;

%ģ̬
Rks = 1/beta - 1+delta;
Gs=0.126;
K_N= ((alpha*Gs^chi)/Rks)^(1/(1-alpha));
ws = (1-alpha)*K_N^alpha*Gs^chi;
Rs = pistar/beta;
Ns = 1/3;
Ks = K_N*Ns;
Is = delta*Ks;
Ys = K_N^alpha*Gs^chi*Ns;
Cs = Ys - Is-Gs;
ms = Cs*pistar; %CIA constraint, real money
m0s=ms/epsilonm0s;
lambdas = beta/Cs^sigma/pistar; %money holding foc
mus = 1/Cs^sigma - lambdas; 
theta = ws*lambdas/Ns^eta;
ls=sb*Rs*Ys+ms;
taos=Gs+ms*(1/Rs-1)+ls*(1/pistar-1/Rs);

model;


%̲
exp(Y) = exp(A)*exp(K(-1))^alpha*exp(N)^(1-alpha)*exp(G)^chi;%
exp(w) = (1-alpha)*exp(A)*exp(K(-1))^alpha*exp(N)^(-alpha)*exp(G)^chi;%Ͷһ
exp(Rk) = alpha*exp(A)*exp(K(-1))^(alpha -1)*exp(N)^(1-alpha)*exp(G)^chi;  %ʱһ
A= rhoA*A(-1) + ea;   %


%ͥ
  
exp(K) = exp(I) + exp(K(-1))*(1 - delta );%ʱ۷
theta*exp(eta*N)*exp(epsilonN) = exp(lambda)*exp(w);%Ͷ
exp(lambda) = beta*(exp(lambda(+1))* ( exp(Rk(+1)) + 1-delta) );%ʱŷ
exp(lambda) = beta*(exp(lambda(+1))* ( exp(R)/exp(pi(+1)) ));  %ծȯŷ
exp(lambda) = beta*(exp(mu(+1)) +exp(lambda(+1)))/exp(pi(+1));   %ʵʻ
epsilonN=rhoN*epsilonN(-1)+eN;    %Ͷ
1/exp(C*sigma) = exp(lambda) + exp(mu); %߼
exp(m(-1)) = exp(C)*exp(pi); %CIA



%

exp(l)=(exp(R)/exp(pi))*exp(l(-1))+exp(R)*(exp(G)-exp(tao))-exp(m)*(exp(R)-1);  %Ԥ㷽̣
exp(tao)-taos=gama*(exp(l(-1))-ls);  %
exp(m)=(3+exp(epsilonm0))*exp(m0);   %M0M2תϵ
m0-log(m0s)=rhom0*(m0(-1)-log(m0s))+em0;  %m0
G-log(Gs)=rhog*(G(-1)-log(Gs))+eg;

%
  
dlnm = (1-rhom)*log(pistar) - (pi) +rhom*(pi(-1)) + rhom*dlnm(-1) +em;%ҹʷ
dlnm = m - m(-1);   %ҹʵĶ

%г
exp(Y) = exp(I) + exp(C)+exp(G);


end;

initval;
Y=log(Ys);
K=log(Ks);
N=log(Ns);
G=log(Gs);
w=log(ws);
Rk=log(Rks);
C=log(Cs);
lambda=log(lambdas);
mu=log(mus);
R=log(Rs);
I=log(Is);
l=log(ls);
tao=log(taos);
m0=log(m0s);
m=log(ms);
pi=log(pistar);
A=0;
dlnm = 0;
epsilonm0=log(6.15);
epsilonN=0;



end;

%resid(1);
%steady;
%resid;                            
%check;
%steady;
%model_diagnostics;

shocks;
var eN;
stderr 1;

var em;
stderr 0.1;

%var eN;
%stderr 3;
end;
steady;
resid;

stoch_simul(periods=1000,irf=40,order=1) C Y K N I pi ; 

initial_condition_states = repmat(oo_.dr.ys,1,M_.maximum_lag);
shock_matrix = zeros(options_.irf,M_.exo_nbr); %create shock matrix with number of time periods in columns Ϊλʱ

shock_matrix(1,strmatch('eN',M_.exo_names,'exact')) = 1; 
shock_matrix(1+1,strmatch('em',M_.exo_names,'exact')) = 0.1; 

y2 = simult_(M_,options_,initial_condition_states,oo_.dr,shock_matrix,1);
y_IRF = y2(:,M_.maximum_lag+1:end)-repmat(oo_.dr.ys,1,options_.irf);

figure
subplot(3,2,1)
plot(y_IRF(strmatch('C',M_.endo_names,'exact'),:)); % use strmatch to select values
title('Consumption');
subplot(3,2,2)
plot(y_IRF(strmatch('Y',M_.endo_names,'exact'),:));
title('Output');
subplot(3,2,3)
plot(y_IRF(strmatch('K',M_.endo_names,'exact'),:));
title('Captial');

subplot(3,2,4)
plot(y_IRF(strmatch('N',M_.endo_names,'exact'),:));
title('Labor');

subplot(3,2,5)
plot(y_IRF(strmatch('I',M_.endo_names,'exact'),:));
title('Invest');

subplot(3,2,6)
plot(y_IRF(strmatch('pi',M_.endo_names,'exact'),:));
title('Inflation');

/*figure
for ii=1:M_.orig_endo_nbr
    subplot(5,4,ii)
    if max(abs(y_IRF(ii,:)))>1e-12 %get rid of numerical inaccuracies ֵ
        plot(y_IRF(ii,:));
    else
        plot(zeros(options_.irf,1));
    end
    title(deblank(M_.endo_names(ii,:)));
end  */









